View a markdown version of this page

StartQuery - AWS IoT SiteWise

StartQuery

Starts an asynchronous SQL query against workspace telemetry, annotations, data segment, and dataset data.

Request Syntax

POST /workspaces/workspaceName/queries HTTP/1.1 Content-type: application/json { "clientToken": "string", "queryStatement": "string" }

URI Request Parameters

The request uses the following URI parameters.

workspaceName

The name of the workspace to query.

Length Constraints: Minimum length of 1. Maximum length of 64.

Pattern: ^[a-zA-Z0-9_-]+$

Required: Yes

Request Body

The request accepts the following data in JSON format.

clientToken

A unique case-sensitive identifier that you can provide to ensure the idempotency of the request. Don't reuse this client token if a new idempotent request is required.

Type: String

Length Constraints: Minimum length of 36. Maximum length of 64.

Pattern: \S{36,64}

Required: No

queryStatement

The SQL query to execute against the workspace telemetry, annotations, data segment, and dataset data.

Type: String

Length Constraints: Minimum length of 1. Maximum length of 10240.

Required: Yes

Response Syntax

HTTP/1.1 202 Content-type: application/json { "queryId": "string", "status": "string" }

Response Elements

If the action is successful, the service sends back an HTTP 202 response.

The following data is returned in JSON format by the service.

queryId

The unique identifier for the query execution.

Type: String

Length Constraints: Minimum length of 1. Maximum length of 64.

Pattern: [a-zA-Z0-9-]+

status

The initial query status. The value is always SUBMITTED upon creation.

Type: String

Valid Values: SUBMITTED | RUNNING | COMPLETED | FAILED | CANCELED | CANCELING

Errors

For information about the errors that are common to all actions, see Common Error Types.

AccessDeniedException

Access is denied.

HTTP Status Code: 403

ConflictingOperationException

Your request has conflicting operations. This can occur if you're trying to perform more than one operation on the same resource at the same time.

resourceArn

The ARN of the resource that conflicts with this operation.

resourceId

The ID of the resource that conflicts with this operation.

HTTP Status Code: 409

InternalFailureException

AWS IoT SiteWise can't process your request right now. Try again later.

HTTP Status Code: 500

InvalidRequestException

The request isn't valid. This can occur if your request contains malformed JSON or unsupported characters. Check your request and try again.

HTTP Status Code: 400

ResourceNotFoundException

The requested resource can't be found.

HTTP Status Code: 404

ThrottlingException

Your request exceeded a rate limit. For example, you might have exceeded the number of AWS IoT SiteWise assets that can be created per second, the allowed number of messages per second, and so on.

For more information, see Quotas in the AWS IoT SiteWise User Guide.

HTTP Status Code: 429

See Also

For more information about using this API in one of the language-specific AWS SDKs, see the following: